<?php

/*************************************************************************
 * [XenCustomize] Profile Audio Player © 2023 XenCustomize.com
 * All Rights Reserved.
 *************************************************************************/

namespace XenCustomize\ProfileAudioPlayer\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class ProfileAudio extends Entity
{
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_xcu_profile_audio';
        $structure->shortName = 'XenCustomize\ProfileAudioPlayer:ProfileAudio';
        $structure->primaryKey = 'user_id';

        $structure->columns = [
            'user_id' => ['type' => self::UINT, 'required' => true],
            
            'album_1' => ['type' => self::STR, 'default' => ''],
            'albumart_1' => ['type' => self::STR, 'default' => ''],
            'artist_1' => ['type' => self::STR, 'default' => ''],
            'audio_url_1' => ['type' => self::STR, 'default' => ''],
            'title_1' => ['type' => self::STR, 'default' => ''],

            'album_2' => ['type' => self::STR, 'default' => ''],
            'albumart_2' => ['type' => self::STR, 'default' => ''],
            'artist_2' => ['type' => self::STR, 'default' => ''],
            'audio_url_2' => ['type' => self::STR, 'default' => ''],
            'title_2' => ['type' => self::STR, 'default' => ''],

            'album_3' => ['type' => self::STR, 'default' => ''],
            'albumart_3' => ['type' => self::STR, 'default' => ''],
            'artist_3' => ['type' => self::STR, 'default' => ''],
            'audio_url_3' => ['type' => self::STR, 'default' => ''],
            'title_3' => ['type' => self::STR, 'default' => ''],

            'album_4' => ['type' => self::STR, 'default' => ''],
            'albumart_4' => ['type' => self::STR, 'default' => ''],
            'artist_4' => ['type' => self::STR, 'default' => ''],
            'audio_url_4' => ['type' => self::STR, 'default' => ''],
            'title_4' => ['type' => self::STR, 'default' => ''],

            'album_5' => ['type' => self::STR, 'default' => ''],
            'albumart_5' => ['type' => self::STR, 'default' => ''],
            'artist_5' => ['type' => self::STR, 'default' => ''],
            'audio_url_5' => ['type' => self::STR, 'default' => ''],
            'title_5' => ['type' => self::STR, 'default' => ''],

            'album_6' => ['type' => self::STR, 'default' => ''],
            'albumart_6' => ['type' => self::STR, 'default' => ''],
            'artist_6' => ['type' => self::STR, 'default' => ''],
            'audio_url_6' => ['type' => self::STR, 'default' => ''],
            'title_6' => ['type' => self::STR, 'default' => ''],

            'album_7' => ['type' => self::STR, 'default' => ''],
            'albumart_7' => ['type' => self::STR, 'default' => ''],
            'artist_7' => ['type' => self::STR, 'default' => ''],
            'audio_url_7' => ['type' => self::STR, 'default' => ''],
            'title_7' => ['type' => self::STR, 'default' => ''],

            'album_8' => ['type' => self::STR, 'default' => ''],
            'albumart_8' => ['type' => self::STR, 'default' => ''],
            'artist_8' => ['type' => self::STR, 'default' => ''],
            'audio_url_8' => ['type' => self::STR, 'default' => ''],
            'title_8' => ['type' => self::STR, 'default' => ''],

            'album_9' => ['type' => self::STR, 'default' => ''],
            'albumart_9' => ['type' => self::STR, 'default' => ''],
            'artist_9' => ['type' => self::STR, 'default' => ''],
            'audio_url_9' => ['type' => self::STR, 'default' => ''],
            'title_9' => ['type' => self::STR, 'default' => ''],

            'album_10' => ['type' => self::STR, 'default' => ''],
            'albumart_10' => ['type' => self::STR, 'default' => ''],
            'artist_10' => ['type' => self::STR, 'default' => ''],
            'audio_url_10' => ['type' => self::STR, 'default' => ''],
            'title_10' => ['type' => self::STR, 'default' => ''],
        ];

        $structure->relations = [
            'User' => [
                'entity' => 'XF:User',
                'type' => self::TO_ONE,
                'conditions' => [
                    ['user_id', '=', '$user_id']
                ],
                'primary' => true
            ],
        ];

        return $structure;
    }
}
