<?php

/*************************************************************************
 * [XenCustomize] Profile Audio Player © 2023 XenCustomize.com
 * All Rights Reserved.
 *************************************************************************/

namespace XenCustomize\ProfileAudioPlayer;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	// ############################################ INSTALL STEPS #########################

	public function installStep1()
    {
        $sm = $this->schemaManager();

        $sm->createTable('xf_xcu_profile_audio', function(Create $table)
        {
            $table->addColumn('user_id', 'int');

            $table->addColumn('album_1', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_1', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_1', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_1', 'varchar', 255)->setDefault('');
            $table->addColumn('title_1', 'varchar', 255)->setDefault('');

            $table->addColumn('album_2', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_2', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_2', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_2', 'varchar', 255)->setDefault('');
            $table->addColumn('title_2', 'varchar', 255)->setDefault('');

            $table->addColumn('album_3', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_3', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_3', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_3', 'varchar', 255)->setDefault('');
            $table->addColumn('title_3', 'varchar', 255)->setDefault('');

            $table->addColumn('album_4', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_4', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_4', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_4', 'varchar', 255)->setDefault('');
            $table->addColumn('title_4', 'varchar', 255)->setDefault('');

            $table->addColumn('album_5', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_5', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_5', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_5', 'varchar', 255)->setDefault('');
            $table->addColumn('title_5', 'varchar', 255)->setDefault('');

            $table->addColumn('album_6', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_6', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_6', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_6', 'varchar', 255)->setDefault('');
            $table->addColumn('title_6', 'varchar', 255)->setDefault('');

            $table->addColumn('album_7', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_7', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_7', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_7', 'varchar', 255)->setDefault('');
            $table->addColumn('title_7', 'varchar', 255)->setDefault('');

            $table->addColumn('album_8', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_8', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_8', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_8', 'varchar', 255)->setDefault('');
            $table->addColumn('title_8', 'varchar', 255)->setDefault('');

            $table->addColumn('album_9', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_9', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_9', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_9', 'varchar', 255)->setDefault('');
            $table->addColumn('title_9', 'varchar', 255)->setDefault('');

            $table->addColumn('album_10', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_10', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_10', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_10', 'varchar', 255)->setDefault('');
            $table->addColumn('title_10', 'varchar', 255)->setDefault('');
            
            $table->addPrimaryKey('user_id');
        });
    }

    // ############################################ POST INSTALL STEPS #########################
    
    public function postInstall(array &$stateChanges)
    {
        if ($this->applyDefaultPermissions())
        {
            $this->app->jobManager()->enqueueUnique(
                'permissionRebuild',
                'XF:PermissionRebuild',
                [],
                false
            );
        }
    }

    protected function applyDefaultPermissions($previousVersion = null)
    {
        $applied = false;
    
        if (!$previousVersion)
        {
            $this->applyGlobalPermission('xcuProfileAudioPlayer', 'viewPlayer', 'profilePost', 'view');
            $this->applyGlobalPermission('xcuProfileAudioPlayer', 'addAudio', 'profilePost', 'post');
            $this->applyGlobalPermission('xcuProfileAudioPlayer', 'uploadAudio', 'profilePost', 'uploadAttachment');
    
            $applied = true;
        }

        return $applied;
    }

    // ############################################ UPGRADE 1.0.1 STEPS #########################

    // Upgrade from v1.0.0 to v1.0.1
    public function upgrade1000170Step1(array $stepParams)
    {
        $sm = $this->schemaManager();

        $sm->alterTable('xf_xcu_profile_audio', function(Alter $table)
        {
            $table->addColumn('album_6', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_6', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_6', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_6', 'varchar', 255)->setDefault('');
            $table->addColumn('title_6', 'varchar', 255)->setDefault('');

            $table->addColumn('album_7', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_7', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_7', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_7', 'varchar', 255)->setDefault('');
            $table->addColumn('title_7', 'varchar', 255)->setDefault('');

            $table->addColumn('album_8', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_8', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_8', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_8', 'varchar', 255)->setDefault('');
            $table->addColumn('title_8', 'varchar', 255)->setDefault('');

            $table->addColumn('album_9', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_9', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_9', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_9', 'varchar', 255)->setDefault('');
            $table->addColumn('title_9', 'varchar', 255)->setDefault('');

            $table->addColumn('album_10', 'varchar', 255)->setDefault('');
            $table->addColumn('albumart_10', 'varchar', 255)->setDefault('');
            $table->addColumn('artist_10', 'varchar', 255)->setDefault('');
            $table->addColumn('audio_url_10', 'varchar', 255)->setDefault('');
            $table->addColumn('title_10', 'varchar', 255)->setDefault('');
        });
    }

    // ############################################ POST UPGRADE STEPS #########################
    
    public function postUpgrade($previousVersion, array &$stateChanges)
    {
        if ($previousVersion < 1000270)
        {
            // Apply new permission for version 1000270 (1.0.2)
            $this->applyGlobalPermission('xcuProfileAudioPlayer', 'uploadAudio', 'profilePost', 'uploadAttachment');
            
            // Rebuild permissions
            $this->app->jobManager()->enqueueUnique(
                'permissionRebuild',
                'XF:PermissionRebuild',
                [],
                false
            );
        }
    }

    // ############################################ UNINSTALL STEPS #########################

    public function uninstallStep1()
    {
        $sm = $this->schemaManager();

        $sm->dropTable(
            'xf_xcu_profile_audio'
        );
    }
}