<?php

/*************************************************************************
 * [XenCustomize] Profile Audio Player © 2023 XenCustomize.com
 * All Rights Reserved.
 *************************************************************************/

namespace XenCustomize\ProfileAudioPlayer\XF\Service\Asset;

use XF\FileWrapper;

class Upload extends XFCP_Upload
{
    public function setImageFromUpload(\XF\Http\Upload $upload)
    {
        $allowedExtensions = self::getValidAssetExtensions();

        // Check if the uploaded file extension is allowed
        if (!in_array(strtolower($upload->getExtension()), $allowedExtensions)) {
            $this->error = \XF::phrase('xcu_pap_invalid_file_extension');
            return false;
        }

        // Skip all validation except the allowed extension check
        return $this->setImageFromFile($upload->getFileWrapper());
    }

    public function setImageFromFile(\XF\FileWrapper $file)
    {
        $fileName = preg_replace('#[^a-z0-9_.-]#i', '', $file->getFileName());

        // No need to check the extension again; we already did that
        $this->tempFile = $file->getFilePath();
        $this->fileName = $fileName;
        return true;
    }

    public static function getValidAssetExtensions()
    {
        return ['gif', 'jpg', 'jpeg', 'jpe', 'png', 'svg', 'mp3', 'wav', 'aac', 'flac', 'm4a', 'ogg', 'oga', 'amb', 'm4r', 'opus'];
    }
}